//Below is the 78 chars line!
//----------------------------------------------------------------------------
//Jason Winnebeck

#include "chat.h"
#include <string.h>
#include <stdio.h>
#include <time.h>

#include <sys/socket.h> //consts and procedures
#include <stdlib.h>     //for atexit()
#include <arpa/inet.h>  //for sockadd_in !!!
#define LinkListConflict
#include <unistd.h>     //for close()
#include <errno.h>
#include <curses.h>

int main() {
  atexit(DisplayError);
  WINDOW* mainscr = initscr();
  scrollok(mainscr, false);
  InitColors();
  if (Init() == ERROR)
    return ERROR;

  if (Connect() == ERROR)
    return ERROR;

  bool exit = false;
  fd_set readfds;

  while (!exit) {
    FD_ZERO(&readfds);
    FD_SET(server, &readfds);
    FD_SET(STDIN, &readfds);

    if (select(server+1, &readfds, NULL, NULL, NULL) == ERROR)
      return ERROR;

    if (FD_ISSET(server, &readfds)) {
      RecvMessage();
      switch(buf[0]) {
        case NEW:
          NewJoin(&buf[1]);
          break;
        case MSG:
          Room << &buf[1] << '\n';
          break;
        case EXIT:
          LeaveCli(&buf[1]);
          break;
        case PING:
          PingResponse();
          break;
      }
    }

    if (FD_ISSET(STDIN, &readfds)) {
      int ch = getch();
      if (ch == 27) {  //27 is ESC
        exit = true;
        Leave();     //Notify server of exit
      } else {
        ungetch(ch);
        if (Message.Update()) {
          char* input = Message.GetInput();
          int newstrlen =
            strlen(Message.GetInput())+2;  //Include NULL and header
          char* msg = new char[newstrlen];
          sprintf(msg, "%c%s", MSG, input);
          SendMessage(msg);
          Message.Reset();
        }
      }
    }
  }

//Cleanup
  endwin();
  printf("Chat exited successfully without error.\n");
  return 0;
}

void SendMessage(char* msg) {
  int msglen = strlen(msg) + 1;//WANT to send NULL
  int sent = 0;                //Amount of data sent so far
  while (sent < msglen) {
    sent += send(server, &msg[sent], msglen-sent, (int)NULL);
    if (sent == -1)
      exit(ERROR);
  }
  gout += sent;                //Update connection stats
  UpdateStats();
}

void RecvMessage() {
  int rec = recv(server, buf, 511, (int)NULL);
  if (rec == ERROR)
    exit(ERROR);
  gin += rec;
  UpdateStats();
}

void PingResponse() {
  int newstrlen =
    2;                         //Ping packet header + NULL

  char* packet = new char[newstrlen];
  sprintf(packet, "%c", PING);
  SendMessage(packet);
}

void Leave() {
  int newstrlen =
    2;                         //Exit packet header + NULL

  char* packet = new char[newstrlen];
  sprintf(packet, "%c", EXIT);
  SendMessage(packet);
}

void LeaveCli(const char* str) {
  int l = Clients.Length();
  Clients.SetToStart();
  for (int c=0; c<l; c++) {
    if (strcmp(str, Clients._GetNext()->name) == 0)
      Clients._DeleteThis();
    else
      Clients._Advance();
  }
  UpdateStats();
  UpdateClilist();
}

void NewJoin(const char* name) {
  int newstrlen = strlen(name) + 1; // Name and NULL

  Clidata* NewClient = new Clidata;
  NewClient->name = new char[newstrlen];
  strcpy(NewClient->name, name);
  Clients._MoveData(NewClient);

  UpdateStats();
  UpdateClilist();
}
