//Below is the 78 chars line!
//----------------------------------------------------------------------------
//Jason Winnebeck

//This is a Linux port of the TextGUI from MUUDPIC

#include <string.h>
#include "window.h"
#include <stdio.h>
#include <stdlib.h>
#include <curses.h>

int InitColors() {
  if (start_color() == ERR)
    return -1;
  init_pair(1, COLOR_BLACK, COLOR_BLACK);
  init_pair(2, COLOR_BLUE, COLOR_BLACK);
  init_pair(3, COLOR_GREEN, COLOR_BLACK);
  init_pair(4, COLOR_CYAN, COLOR_BLACK);
  init_pair(5, COLOR_RED, COLOR_BLACK);
  init_pair(6, COLOR_MAGENTA, COLOR_BLACK);
  init_pair(7, COLOR_YELLOW, COLOR_BLACK);
  init_pair(8, COLOR_WHITE, COLOR_BLACK);

  init_pair(9, COLOR_BLACK, COLOR_BLUE);
  init_pair(10, COLOR_BLUE, COLOR_BLUE);
  init_pair(11, COLOR_GREEN, COLOR_BLUE);
  init_pair(12, COLOR_CYAN, COLOR_BLUE);
  init_pair(13, COLOR_RED, COLOR_BLUE);
  init_pair(14, COLOR_MAGENTA, COLOR_BLUE);
  init_pair(15, COLOR_YELLOW, COLOR_BLUE);
  init_pair(16, COLOR_WHITE, COLOR_BLUE);

  init_pair(17, COLOR_BLACK, COLOR_GREEN);
  init_pair(18, COLOR_BLUE, COLOR_GREEN);
  init_pair(19, COLOR_GREEN, COLOR_GREEN);
  init_pair(20, COLOR_CYAN, COLOR_GREEN);
  init_pair(21, COLOR_RED, COLOR_GREEN);
  init_pair(22, COLOR_MAGENTA, COLOR_GREEN);
  init_pair(23, COLOR_YELLOW, COLOR_GREEN);
  init_pair(24, COLOR_WHITE, COLOR_GREEN);

  init_pair(25, COLOR_BLACK, COLOR_CYAN);
  init_pair(26, COLOR_BLUE, COLOR_CYAN);
  init_pair(27, COLOR_GREEN, COLOR_CYAN);
  init_pair(28, COLOR_CYAN, COLOR_CYAN);
  init_pair(29, COLOR_RED, COLOR_CYAN);
  init_pair(30, COLOR_MAGENTA, COLOR_CYAN);
  init_pair(31, COLOR_YELLOW, COLOR_CYAN);
  init_pair(32, COLOR_WHITE, COLOR_CYAN);

  init_pair(33, COLOR_BLACK, COLOR_RED);
  init_pair(34, COLOR_BLUE, COLOR_RED);
  init_pair(35, COLOR_GREEN, COLOR_RED);
  init_pair(36, COLOR_CYAN, COLOR_RED);
  init_pair(37, COLOR_RED, COLOR_RED);
  init_pair(38, COLOR_MAGENTA, COLOR_RED);
  init_pair(39, COLOR_YELLOW, COLOR_RED);
  init_pair(40, COLOR_WHITE, COLOR_RED);

  init_pair(41, COLOR_BLACK, COLOR_MAGENTA);
  init_pair(42, COLOR_BLUE, COLOR_MAGENTA);
  init_pair(43, COLOR_GREEN, COLOR_MAGENTA);
  init_pair(44, COLOR_CYAN, COLOR_MAGENTA);
  init_pair(45, COLOR_RED, COLOR_MAGENTA);
  init_pair(46, COLOR_MAGENTA, COLOR_MAGENTA);
  init_pair(47, COLOR_YELLOW, COLOR_MAGENTA);
  init_pair(48, COLOR_WHITE, COLOR_MAGENTA);

  init_pair(49, COLOR_BLACK, COLOR_YELLOW);
  init_pair(50, COLOR_BLUE, COLOR_YELLOW);
  init_pair(51, COLOR_GREEN, COLOR_YELLOW);
  init_pair(52, COLOR_CYAN, COLOR_YELLOW);
  init_pair(53, COLOR_RED, COLOR_YELLOW);
  init_pair(54, COLOR_MAGENTA, COLOR_YELLOW);
  init_pair(55, COLOR_YELLOW, COLOR_YELLOW);
  init_pair(56, COLOR_WHITE, COLOR_YELLOW);

  init_pair(57, COLOR_BLACK, COLOR_WHITE);
  init_pair(58, COLOR_BLUE, COLOR_WHITE);
  init_pair(59, COLOR_GREEN, COLOR_WHITE);
  init_pair(60, COLOR_CYAN, COLOR_WHITE);
  init_pair(61, COLOR_RED, COLOR_WHITE);
  init_pair(62, COLOR_MAGENTA, COLOR_WHITE);
  init_pair(63, COLOR_YELLOW, COLOR_WHITE);
  init_pair(64, COLOR_WHITE, COLOR_WHITE);
}

CWindow::CWindow() {
}

CWindow::CWindow(int x2, int y2, int w2, int h2) {
  title = new char[2]; //Create a valid string
  title[0] = ' ';
  title[1] = '\0';

  //subtracts 1 because UNIX starts at 0, not 1
  mainWin = newwin(h2, w2, y2-1, x2-1);
  inside = newwin(h2-2, w2-2, y2, x2);
  scrollok(inside, true);

  SetColors(0, 7, 7);
}

CWindow::~CWindow() {
  if (title)
    delete[] title;

  delwin(mainWin);
  delwin(inside);
}

void CWindow::Move(int x2, int y2, int w2, int h2) {
  delwin(mainWin);
  delwin(inside);

  mainWin = newwin(h2, w2, y2-1, x2-1);
  inside = newwin(h2-2, w2-2, y2, x2);
  scrollok(inside, true);

  SetColors(0, 7, 7);
}

void CWindow::SetName(const char* title2) {
  if (title)
    delete[] title;

  int newstrlen = strlen(title2) + 1; //Don't forget NULL!
  title = new char[newstrlen];
  strcpy(title, title2);
}

void CWindow::SetColors(int back2, int fore2, int text2) {
  if (fore2 > 7) {
    fore2 -= 8;
    wattron(mainWin, A_BOLD);
  } else {
    wattroff(mainWin, A_BOLD);
  }

  int pair = back2 * 8 + fore2 + 1;
  wattron(mainWin, COLOR_PAIR(pair));

  if (text2 > 7) {
    text2 -= 8;
    wattron(inside, A_BOLD);
  } else {
    wattroff(inside, A_BOLD);
  }

  pair = back2 * 8 + text2 + 1;
  wattron(inside, COLOR_PAIR(pair));
}

void CWindow::Clear() {
  werase(inside);
  wmove(inside, 0, 0);
  wrefresh(inside);
}

void CWindow::Draw() {
  int w, h;  
  getmaxyx(mainWin, h, w);
  h--; w--;

  //Window top
  char line[81];                  //Temp output buf
  int curr;                       //current position in line
  curr = sprintf(line, "͵ %s ", title);
  int rest = w - (4 + strlen(title) + 1) - 1;
    //Total width minus title and sides and upper right corner
  for (int c=0; c<rest; c++)
    line[curr+c] = '';
  line[rest+curr] = '';
  line[rest+curr+1] = '\0';
  mvwprintw(mainWin, 0, 0, line);

  //Middle window area (DO NOT CLEAR)
  for (int c=1; c<h; c++) {
    mvwprintw(mainWin, c, 0, "");
    mvwprintw(mainWin, c, w, "");
  }

  //Bottom line
  line[0] = '';
  for (int c=1; c<w; c++)
    line[c] = '';
  line[w] =  '';
  line[w+1] = '\0';
  mvwprintw(mainWin, h, 0, "%s", line);

  wrefresh(mainWin);
  wrefresh(inside);
}

void CWindow::Erase() {
  wattrset(mainWin, COLOR_PAIR(8));
  werase(mainWin);
  wmove(inside, 0, 0);
  wrefresh(mainWin);
}

void CWindow::Backspace() {
  int y, x;
  getyx(inside, y, x);
  wmove(inside, y, x-1);
  wprintw(inside, " ");
  wmove(inside, y, x-1);
  wrefresh(inside);
}

int CWindow::scanf(const char* format, ...) {
  va_list ap;
  va_start(ap, format);
  return vwscanw(inside, format, ap);
  va_end(ap);
}

CWindow& CWindow::operator << (char ch) {
  wprintw(inside, "%c", ch);
  wrefresh(inside);
  return *this;
}

int CWindow::FindNewlines(char *str) {
  //The function is interesting. It replaces the newlines with NULLs so a
  // cputs loop can CORRECTLY implement newline chars, and linefeeding,
  // rather than just dropping down.
  int l = strlen(str);
  for (int c=0; c<l; c++)
    if (str[c] == '\n') {
      str[c] = '\0';
    }
  return l;  //Return the length so we know when to stop
}

CWindow& CWindow::operator << (const char* str) {
  char* temp = new char[strlen(str)+1];
  strcpy(temp, str);

  int l = FindNewlines(temp);     //Replace with NULLs, get len
  int disp = 0;                   //Amount displayed so far

  while (disp < l) {
    wprintw(inside, "%s", &temp[disp]);//Output text
    disp += strlen(&temp[disp])+1;//Update pos, skip over that NULL
    if (disp <= l) {              //if not at end do a proper linefeed
      wprintw(inside, "\n");      //Advance a line, scrolling if needed
    }
  }

  wrefresh(inside);
  return *this;
}

CWindow& CWindow::operator << (int x) {
  wprintw(inside, "%i", x);
  wrefresh(inside);
  return *this;
}

CWindow& CWindow::operator << (double x) {
  wprintw(inside, "%f", x);
  wrefresh(inside);
  return *this;
}

CWindow& CWindow::operator << (ostrstream* &out) {
  *out << '\0';                   //NULL terminate buffer
  char* str = out->str();
  int l = FindNewlines(str);      //Replace with NULLs, get len
  int disp = 0;                   //Amount displayed so far

  while (disp < l) {
    wprintw(inside, "%s", &str[disp]);//Output text
    disp += strlen(&str[disp])+1; //Update pos, skip over that NULL
    if (disp <= l) {              //if not at end do a proper linefeed
      wprintw(inside, "\n");      //Advance a line, scrolling if needed
    }
  }

  delete out;                     //Erase out output string
  out = NULL;
  wrefresh(inside);
  return *this;
}






